unsigned char cht[8*16];

unsigned char chtypes[12][16] ={
{0,0,0,0,0,0,0,254,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,24,24,0,0,0,0},
{0,0,56,108,198,198,214,214,198,198,108,56,0,0,0,0},
{0,0,24,56,120,24,24,24,24,24,24,126,0,0,0,0},
{0,0,124,198,6,12,24,48,96,192,198,254,0,0,0,0},
{0,0,124,198,6,6,60,6,6,6,198,124,0,0,0,0},
{0,0,12,28,60,108,204,254,12,12,12,30,0,0,0,0},
{0,0,254,192,192,192,252,6,6,6,198,124,0,0,0,0},
{0,0,56,96,192,192,252,198,198,198,198,124,0,0,0,0},
{0,0,254,198,6,6,12,24,48,48,48,48,0,0,0,0},
{0,0,124,198,198,198,124,198,198,198,198,124,0,0,0,0},
{0,0,124,198,198,198,126,6,6,6,12,120,0,0,0,0}};

struct TInfRec {
 char _Signature[4];
 unsigned int _Version;
 char* _pszOEM;
 unsigned long _Abilities;
 unsigned int* _Modes;
 unsigned char _FormInfoRec[18];
 unsigned char _Data[238];
 unsigned char _nothing[256];
} InfRec;

struct TModInf {
 unsigned int _ModeAttrs;
 unsigned char _WinAAtrs;
 unsigned char _WinBAttrs;
 unsigned int _WinGran,
	      _WinSize,
	      _WinASeg,
	      _WinBSeg;
 unsigned long _Handler;
 unsigned int _ScanLineW;
 unsigned int _HorzRes,
	      _VertRes;
 unsigned char _CharWidth,
	       _CharHeight,
	       _NumPlanes,
	       _BPP,
	       _NumBanks,
	       _MemModel,
	       _BankSize,
	       _Reserved[227],
	       _Rest[256];
} mdInf;

unsigned int oldbank,newbank;

void SetBank(int bank)
{
 asm {
  mov ax,0x4f05
  xor bx,bx
  mov dx,bank
  int 0x10
 }
}

long RGB(unsigned char r, unsigned char g, unsigned char b)
{
unsigned long int c;
 switch(mdInf._BPP)
 {
  case 15: c=(unsigned long int)r<<10+(unsigned long int)g<<5+b;
	   break;
  case 16: c=(unsigned long int)r<<11+(unsigned long int)g<<5+b;
	   break;
  case 24:
  case 32: c=(unsigned long int)r<<16+(unsigned long int)g<<8+b;
 }
return c;
}

void PutPixel(unsigned int x, unsigned int y, unsigned char col)
{
register unsigned long addr=((long)mdInf._ScanLineW*y)+x;
register unsigned int raddr = addr % 65536;
 newbank=addr>>16;
 if(oldbank!=newbank)
 {
  oldbank=newbank;
  asm {
   mov ax,0x4f05
   xor bx,bx
   mov dx,newbank
   int 0x10
  }
 }
 asm {
  mov ax,mdInf._WinASeg
  mov es,ax
  mov di,raddr
  mov al,col
  stosb
 }
}

void PutPixel24(int x, int y, unsigned long c)
{
unsigned long l,k;
unsigned int bank,raddr,z,m,col,col1,col2;
 switch(mdInf._BPP)
 {
  case 15:
  case 16: l=((long)mdInf._ScanLineW*(long)y)+(long)x*2;
	   bank=l*(64/mdInf._WinGran)>>16;
	   SetBank(bank);
	   raddr=(unsigned int)l;
	   col=(unsigned int)c;
	   asm {
	    mov ax,mdInf._WinASeg
	    mov es,ax
	    mov di,raddr
	    mov ax,col
	    stosw
	   }
	   break;
  case 24:
  case 32:l=((long)mdInf._ScanLineW*(long)y)+(long)x*4;
	  k=(long)mdInf._WinGran*1024;
	  z=l&0xff;
	  bank=l*(64/mdInf._WinGran)>>16;
	  SetBank(bank);
	  col=(unsigned int)c;
	  if(z<k-2)
	  {
	   raddr=z;
	   col1=c>>16;
	   col2=c&0xffff;
	   asm {
	    mov ax,mdInf._WinASeg
	    mov es,ax
	    mov di,raddr
	    mov ax,col1
	    stosw
	    mov ax,col2
	    stosw
	   }
	  }
	  else
	  {
	   raddr=z;
	   asm {
	    mov ax,mdInf._WinASeg
	    mov es,ax
	    mov di,raddr
	    mov ax,col
	    stosw
	   }
	   bank=(l+k)*(64/mdInf._WinGran)>>16;
	   SetBank(bank);
	   col=c/0x1000;
	   asm {
	    mov ax,mdInf._WinASeg
	    mov es,ax
	    mov di,0
	    mov ax,col
	    stosw
	   }

	  }


 }
}


void SetMode(unsigned int mode)
{
 asm {
  mov di,offset mdInf
  push ds
  pop es
  mov ax,0x4f01;
  mov cx,mode
  int 0x10
  mov ax,0x4f02
  mov bx,mode
  int 0x10
 }
}

void GetModeInfo(unsigned int oldp)
{
 asm {
    mov di,offset mdInf
    push ds
    pop es
    mov ax,0x4f01;
    mov cx,oldp
    int 0x10
   }

}

int Init()
{
char tmp;
 oldbank=0;
 asm {
  mov ax,0x4f00
  mov di, offset InfRec
  push ds
  pop es
  int 0x10
  mov tmp,al
 }
 return (tmp==0x4f);
}

void line(int x,int y,int x2,int y2, char col)
{
int d,dx,dy,ai,bi,xi,yi;
 if(x<x2){xi=1;dx=x2-x;} else{ xi=-1;dx=x-x2;}
 if(y<y2){yi=1;dy=y2-y;} else{ yi=-1;dy=y-y2;}
 PutPixel(x,y,col);
 if(dx>dy)
 {
  ai=(dy-dx)*2;
  bi=dy*2;
  d=bi-dx;
  do
  {
   if(d>=0){y+=yi;d+=ai;} else d+=bi;
   x+=xi;
   PutPixel(x,y,col);
  }while(x!=x2);
 }
 else
 {
  ai=(dx-dy)*2;
  bi=dx*2;
  d=bi-dy;
  do
  {
   if(d>=0){x+=xi;d+=ai;} else d+=bi;
   y+=yi;
   PutPixel(x,y,col);
  }while(y!=y2);
 }
}

void decod_chr(unsigned char cod)
{
unsigned int j,i,tofs;
unsigned char cur,b;
 tofs=1;
 switch(cod)
 {
  case '-':cur=0;
	   break;
  case '.':cur=1;
	   break;
  default: if((cod>=48)&&(cod<=57))cur=cod-48+2;
 }
 for(i=0;i<16;i++)
 {
  b=chtypes[cur][tofs];

  for(j=0;j<8;j++)
  {
   cht[8*i+j]=0;
   asm {
    xor al,al
    rcl b,1
    adc al,0
    mov bx,i
    dec bx
    shl bx,3
    add bx,j
    mov byte ptr cht[bx],al
   }
  }
  tofs++;
 }
}
void print(char* s, int curx, int cury, int strl,unsigned char col)
{
int i,j,si;
 for(si=0;si<strl;si++)
 {
  decod_chr(s[si]);
  for(i=0;i<16;i++)
   for(j=0;j<7;j++)
    if(cht[8*i+j]!=0)PutPixel(curx+si*8+j,i+cury,col);
 }
}

void rect(int x1, int y1, int x2, int y2, unsigned char col)
{
 line(x1,y1,x2,y1,col);
 line(x2,y1,x2,y2,col);
 line(x2,y2,x1,y2,col);
 line(x1,y2,x1,y1,col);
}