#include <windows.h>
#include <ddraw.h>
#include <stdlib.h>
#include <math.h>

//a mogas iranyok
#define LEFT	0
#define DOWN	1
#define RIGHT	2
#define UP		3

//a timer azonositoja
const int TIMER_ID = 1;
//a timer meghivas gyorsasaga, millisecundumba merve
const int TIMER_RATE = 1;

// a DirectDraw objektums
LPDIRECTDRAW lpDD;
// a DirectDraw elsodleges rajzolasi felulet (front buffer)
LPDIRECTDRAWSURFACE lpDDSPrimary;
// a DirectDraw masodlagos rajzolasi felulet (backbuffer)
LPDIRECTDRAWSURFACE lpDDSBack;
// megmondja, hogy a program meg aktiv-e. A WndProc -ban kapja meg az erteket,
// a WM_ACTIVATEAPP uzenet parameterekent
BOOL bActive;
// az ablak osztaly neve
char name[] = "DirectX";
// a mozgatott szoveg
char szMoving[] = "Mozg kty (Esc: vge)";
// az elmozditas x illetve y erteke
int xpos = 0;
int ypos = 0;
//a mozgas iranya
int dir = 0;

// ezek a fuggveny prototipusok vannak ahsznalva 
LRESULT CALLBACK WindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );
BOOL Initialize( HINSTANCE hInstance, int nCmdShow );
/*
 * WinMain - initialization, message loop
 */
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{
    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

    if( !Initialize( hInstance, nCmdShow ) )
    {
        return FALSE;
    }

	// a klasszikus message loop
MSG msg;
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;

} /* WinMain */


/*
 * Felszabaditja a lefoglalt DirectDraw objektumokat, mint magat a DirectDraw
 * objektumot, illetve az elsodleges rajzolasi feluletet
 */
static void ReleaseObjects( void )
{
    if( lpDD != NULL )
    {
        if( lpDDSPrimary != NULL )
        {
            lpDDSPrimary->Release();
            lpDDSPrimary = NULL;
        }
        lpDD->Release();
        lpDD = NULL;
    }
}

/*
 * Az ablak CALLBACK fuggveny
 */
LRESULT CALLBACK WindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{

HDC hdc;

    switch( message )
    {
    case WM_ACTIVATEAPP:
        bActive = wParam;
        break;

    case WM_CREATE:
        break;

    case WM_SETCURSOR:
        SetCursor(NULL);
        return TRUE;

    case WM_TIMER:
        // Flippeljuk a feluelteket
        if( bActive )
        {
			//kirajzolunk a hatterre egy szoveget
            if (lpDDSBack->GetDC(&hdc) == DD_OK)
			{
			
				SetBkColor(hdc,RGB(0,0,0));
				//toroljuk a kirajzolt szoveget
				//lekerjuk a meretet
				SIZE size;
				GetTextExtentPoint(hdc,szMoving,strlen(szMoving),&size);
				//es egy fekete teglalapot rakunk a helyere
				RECT rect;
				rect.left = 256 + xpos;
				rect.top = 0 + ypos;
				rect.right = rect.left + size.cx + 1;
				rect.bottom = rect.top + size.cy + 1;
				FillRect(hdc,&rect,(HBRUSH)GetStockObject(BLACK_BRUSH));
				//uj ertekekt adunk az iranyeltolodasoknak, az iranytol fugoen
				if(dir == LEFT) { //bal
					xpos ++;
				}
				else if(dir == DOWN) { //le
					ypos ++;
				}
				else if(dir == RIGHT) { //jobb
					xpos --;
				}
				else if(dir == UP) { //fel
					ypos --;
				}
				//ujra kirajzoljuk
				SetTextColor(hdc,RGB(127,255,255));
				TextOut( hdc, 256 + xpos, 0 + ypos, szMoving, strlen(szMoving));
				//beallitjuk az uj iranyt, ha szukseges
				if(dir == LEFT && xpos == GetSystemMetrics( SM_CXSCREEN ) - 255 - size.cx) {
					dir = DOWN;
				}
				else if(dir == DOWN && ypos == GetSystemMetrics(SM_CYSCREEN) - size.cy) {
					dir = RIGHT;
				}
				else if(dir == RIGHT && xpos +256 == 0) {
					dir = UP;
				}
				else if(dir == UP && ypos == 256) {
					dir = LEFT;
				}
				else if(dir==LEFT && xpos == 0) {
					dir = UP;
				}
				else if(dir == UP && ypos == 0) {
					dir = LEFT;
				}
				//felszabaditjuk a DC-t
				lpDDSBack->ReleaseDC(hdc);

            }
			//itt most a hatteret az eloterre fogjuk "flippelni"
			//azert van ez a vegtelen cilus, mert "biztosra megyunk"
			//amikor vegeter a flippeles, ugyis kilepunk a ciklusbol
            while( 1 )
            {
                HRESULT ddrval;
                ddrval = lpDDSPrimary->Flip( NULL, 0 );
                if( ddrval == DD_OK )
                {
                    break;
                }
                if( ddrval == DDERR_SURFACELOST )
                {
                    ddrval = lpDDSPrimary->Restore();
                    if( ddrval != DD_OK )
                    {
                        break;
                    }
                }
                if( ddrval != DDERR_WASSTILLDRAWING )
                {
                    break;
                }
            }
        }
        break;
 
    case WM_KEYDOWN:
        switch( wParam )
        {
        case VK_ESCAPE:
            PostMessage(hWnd, WM_CLOSE, 0, 0);
            break;
        }
        break;


    case WM_DESTROY:
        ReleaseObjects();
        PostQuitMessage( 0 );
        break;
    }

    return DefWindowProc(hWnd, message, wParam, lParam);

}

/*
 * Inicializaljuk a program "dolgait"
 */
BOOL Initialize( HINSTANCE hInstance, int nCmdShow )
{
HWND hwnd;
WNDCLASS wc;
DDSURFACEDESC ddsd;
DDSCAPS ddscaps;
HRESULT ddrval;
HDC hdcFore, hdcBack;
char buf[256];

    // az ablak osztaly (window class) inicializalasa
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon( hInstance, IDI_APPLICATION );
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = NULL;
    wc.lpszMenuName = NULL;
    wc.lpszClassName = name;
    RegisterClass( &wc );
    
    // hozunk letre ablakot is
    hwnd = CreateWindowEx(WS_EX_TOPMOST, name, "DirectX Peldaprogram", WS_POPUP,
        0, 0, GetSystemMetrics( SM_CXSCREEN ), GetSystemMetrics( SM_CYSCREEN ),
        NULL, NULL, hInstance, NULL );

    if( !hwnd )
    {
        return FALSE;
    }

    ShowWindow( hwnd, nCmdShow );
    UpdateWindow( hwnd );

     
    // A DirectDraw objektum letrehozasa
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if( ddrval == DD_OK )
    {
        // Exkluziv mod beallitasa
        ddrval = lpDD->SetCooperativeLevel( hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
        if(ddrval == DD_OK )
        {
			//beallitjuk a 640x480x32 bit-es kepernyofelbontast
            ddrval = lpDD->SetDisplayMode( 640, 480, 32 );
            if( ddrval == DD_OK )
            {
                //  Letrehozzuk az elsodleges rajzfeluletet, egy hatterrel (backbuffer)
                ddsd.dwSize = sizeof( ddsd );
                ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
                ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
                ddsd.dwBackBufferCount = 1;
                ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
                if( ddrval == DD_OK )
                {
                    //  Lekerunk egy pointert a bacbuferre
                    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
                    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, 
                                                          &lpDDSBack);
                    if( ddrval == DD_OK )
                    {
                        // Rajzoljunk ki valami erdekessegeket
                        if (lpDDSPrimary->GetDC(&hdcFore) == DD_OK && lpDDSBack->GetDC(&hdcBack) == DD_OK)
                        {
							int i,j;
							for(i=0;i<255;i++)
							{
								for(j=0;j<255;j++)
								{
									int v = (int)(1255*cos(j)*sin(i))%255;
									COLORREF c = RGB(v,i,j);
									SetPixel(hdcBack,i,j,c);
									SetPixel(hdcFore,i,j,c);
								}
							}
                            lpDDSPrimary->ReleaseDC(hdcFore);
                            lpDDSBack->ReleaseDC(hdcBack);
                        }

                        // Hozzunk letre egy timert, hogy tudjuk cserelgetni a feluleteket
                        if( SetTimer( hwnd, TIMER_ID, TIMER_RATE, NULL ) )
                        {
                             return TRUE;
                        }
                    }
                }
            }
        }
    }

    wsprintf(buf, "Direct Draw Inicializalasi hiba (0x%x)\n", ddrval );
    MessageBox( hwnd, buf, "Hiba", MB_OK );
    ReleaseObjects();
    DestroyWindow( hwnd );
    return FALSE;
} 

